﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.OpenAccess;
using Telerik.OpenAccess.SPI.dataobjects;
using NorthwindModel;

namespace BLL
{
    public class Validation
    {
        public static bool ValidateCategory(Category category)
        {
            if (category.CategoryID < 1 || category.CategoryID > int.MaxValue)
            {
                return false;
            }
            if (String.IsNullOrEmpty(category.CategoryName))
            {
                return false;
            }
            return true;
        }

        public static bool ValidateProduct(Product product)
        {
            if (product.ProductID < 1 || product.ProductID > int.MaxValue)
            {
                return false;
            }
            if (product.Category == null)
            {
                return false;
            }
            if (String.IsNullOrEmpty(product.ProductName))
            {
                return false;
            }
            return true;
        }
    }
}
