﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.OpenAccess;
using Telerik.OpenAccess.Query;

namespace MockObjectScope
{
    public class MockedObjectScope:IMockedObjectScope
    {
        private IMockedTransaction transaction;

        #region IMockedObjectScope Members

        public void Add(object newObject)
        {
            if (transaction.IsActive)
            {
                PersistentClassRepository.AddToTemporaryListForInsert(newObject);
            }
            else
            {
                throw new Exception("There is no active transaction");
            }
        }

        public void Remove(object objectToBeRemoved)
        {
            if (transaction.IsActive)
            {
                PersistentClassRepository.AddToTemporaryListForRemove(objectToBeRemoved);
            }
            else
            {
                throw new Exception("There is no active transaction");
            }
        }       

        public IMockedTransaction Transaction
        {
            get { return transaction; }
        }

        #endregion

        public MockedObjectScope()
        {
            transaction = new MockedTransaction();
        }
    }


    public static class ExtensionMethod
    {
        public static IQueryable<T> Extent<T>(this IMockedObjectScope scope)
        {
            return (IQueryable<T>)PersistentClassRepository.PersistentObjects[typeof(T)].AsQueryable();
        }
    }
}
