﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MockObjectScope
{
    public class MockedTransaction:IMockedTransaction
    {
        private bool isActive;

        #region IMockedTransaction Members

        public void Begin()
        {
            if (IsActive == true)
            {
                throw new Exception("Nested Transactions are not allowed");
            }
            else
            {
                this.isActive = true;
            }
        }

        public void Commit()
        {
            if(PersistentClassRepository.TempListForInsert.Count>0)
            {
                foreach (var persistentObject in PersistentClassRepository.TempListForInsert)
                {
                    PersistentClassRepository.Add(persistentObject);
                }
            }
            if (PersistentClassRepository.TempListForRemove.Count > 0)
            {
                foreach (var persistentObject in PersistentClassRepository.TempListForRemove)
                {
                    PersistentClassRepository.Remove(persistentObject);
                }
            }
            isActive = false;
        }

        public void Rollback()
        {
            PersistentClassRepository.TempListForInsert.Clear();
            PersistentClassRepository.TempListForRemove.Clear();
            isActive = false;
        }

        public bool IsActive
        {
            get
            {
                return this.isActive;
            }
        }

        #endregion
    }
}
