﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using MockObjectScope;
using NorthwindModel;
using BLL;

namespace MyOAMockTests
{
    /// <summary>
    /// Summary description for UnitTest1
    /// </summary>
    [TestClass]
    public class ValidationTests
    {
        public static IMockedObjectScope mockedScope;
        public ValidationTests()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        [ClassInitialize()]
        public static void MyClassInitialize(TestContext testContext)
        {
            List<Type> types = new List<Type> { typeof(Category), typeof(Product) };
            PersistentClassRepository.InitializeRepository(types);
            mockedScope = new MockedObjectScope();
        }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void InsertValidProduct_WithInvalidCategory_ShouldNotEnterInTheRepository()
        {
            Product prod = new Product();
            prod.ProductID = 5;
            prod.ProductName = "TestProduct";
            Category cat = new Category();
            int catId;
            int.TryParse("999999999999",out catId);
            cat.CategoryID = catId;
            cat.CategoryName = "TestCategory";
            prod.Category = cat;
            mockedScope.Transaction.Begin();
            if (Validation.ValidateProduct(prod) && Validation.ValidateCategory(prod.Category))
            {
                mockedScope.Add(prod);
                mockedScope.Transaction.Commit();
            }
            else
            {
                mockedScope.Transaction.Rollback();
            }

            IQueryable<Product> productQuery = mockedScope.Extent<Product>().Where(p => p.ProductID == 5);
            Assert.AreEqual(0, productQuery.Count());
        }
    }
}
